require "scanGeneric.rb"
require "Parser.rb"
require "Parsergenerator.rb"
require "Grammatiken.rb"
require "yaml"
#----------------------------------------------------------------------------------#
syntaxDefGram=Grammar.new("<Syntaxdefinition> ->	<Pattern> nl <Token>

<Pattern> -> patterns nl <Patternfolge> nl

<Patternfolge>	-> <PatternItem> nl <Patternfolge>
| <PatternItem>

<PatternItem>	-> name zuweis <regAusdruck>

<Token> -> tokens nl <Tokenfolge> nl

<Tokenfolge> ->	<TokenItem> nl <Tokenfolge> 
| <TokenItem>

<TokenItem>	-> name zuweis name
|	name zuweis <regAusdruck>

<regAusdruck>	-> <regAusdruck> senk <konjungierterAusdruck> 
| <konjungierterAusdruck>


<konjungierterAusdruck>	-> <konjungierterAusdruck> <elementarerAusdruck>
| <elementarerAusdruck>

<elementarerAusdruck>	-> 	auf <regAusdruck> zu 
| name 
|	zeichen 
|	<Zeichenfolge>
| <regAusdruck> eauf zahl minus <obereGrenze> ezu
| gauf zeichen minus zeichen gzu
       
<Zeichenfolge>	-> <Zeichenfolge> zeichen 
|	zeichen

<obereGrenze>	-> zahl 
| stern")
#----------------------------------------------------------------------------------#

scanExample="Patterns:
<addOpPattern> := ($+ | $-)
<multOpPattern> := ($* | $/)
<openingBracketPattern> := $(
<closingBracketPattern> := $)
<letterPattern> := ({$a-$z}|{$A-$Z})
<digitPattern> := {$0-$9}
<namePattern> := <letterPattern> (<letterPattern> | <digitPattern>)[0-*]
<numberPattern> := <digitPattern>[1-*]

Tokens:
<addOp> := <addOpPattern>
<multOp> := <multOpPattern>
<openingBracket> := <openingBracketPattern>
<closingBracket> := <closingBracketPattern>
<name> := <namePattern>
<number> := <numberPattern>"

#----------------------------------------------------------------------------------#
#~scanExample2="Patterns:
#~<addOpPattern> := $-

#~Tokens:
#~<addOp> := <addOpPattern>
#~"
#~scanExample3="patterns nl name zuweis zeichen nl nl tokens nl name zuweis name nl"

#----------------------------------------------------------------------------------#
#~syntaxDefGram2=Grammar.new("S ->	<Pattern> nl <Token>

#~<Pattern> -> patterns

#~<Token> -> tokens")
#~scanExample4="patterns nl tokens"

#----------------------------------------------------------------------------------#

syntaxDefScanner=Scanner.new([["auf ","zu ","gauf ","gzu ","eauf ","ezu ","senk ","minus ","gaense ","stern ","zuweis ","nl ","zahl ","patterns ","tokens ","zeichen ","name "],
  [/[(]/,/[)]/,/\{/,/\}/,/\[/,/\]/,/[|]/,/[-]/,/["]/,/\*/,/:=/,/\n/,/[0-9]\d*/,/Patterns:/,/Tokens:/,/\$\S/,/<\S+>/]])
	
print("+-----------------------------------------------+\n")
print("| Zerlegung mit Zuordnung zu den Token-Klassen: |\n")
print("+-----------------------------------------------+\n\n")
print("Akkumulierte Tokens: \n--------------------\n\n")
tokenString=syntaxDefScanner.bestimme(scanExample)
tokenNamesArray=Array.new
tokenContArray=Array.new
tokenString.each_line do |line|
	tokenNamesArray<<line.split(/[ ]/)[0]
	tokenContArray<<line.split(/[ ]/)[1]
end

tempString=""
tokenNamesArray.each do |name|
	tempString=tempString+name+" "
end
tempString=tempString.chomp
print("\n+-----------------------------------------------+\n")
print("| Input fuer den Parser:                        |\n")
print("+-----------------------------------------------+\n\n")
puts tempString
#----------------------------------------------------------------------------------#
syntaxDefLR0=LR_0.new(syntaxDefGram)
 #~File.open("lr0.automat","w"){|data|
	   #~YAML.dump(syntaxDefLR0,data)
	 #~}

#~load(File.open("lr0.automat"))

#~File.open("syntaxDefLR0.txt","r")
#~syntaxDefLR0=syntaxDefLR0File.read
#~syntaxDefLR0File.close

#~puts ATable.new(syntaxDefLR0).to_s
#~puts UTable.new(syntaxDefLR0).to_s

(Parse.new syntaxDefLR0).parse(scanExample)
gets
syntaxBaum=(Parse.new syntaxDefLR0).to_SB(scanExample)
#~syntaxBaumFile=File.new("syntaxDefTree.txt","w+")
#~#syntaxBaumFile.print(syntaxBaum)
#~syntaxBaumFile.close

	