	@@term_pattern=Regexp.new('Pattern:')
	@@term_token = Regexp.new('Token:')
	@@term_zuweisung=Regexp.new(':=')
	@@term_regexp=Regexp.new('<regexp>') #(\{\$[A-Za-z0-9]-\$[A-Za-z0-9]\})?')
	@@term_patternName=Regexp.new('\w+')
	@@term_tokenName = Regexp.new('\w+')
	
	#~@@nterm_tokenItem=Regexp.new(@@term_tokenName.source+@@term_zuweisung.source+'('+@@term_tokenName.source+'|'+@@term_patternName.source+'|'+@@term_regexp.source+')')
	#~@@nterm_tokenFolge=Regexp.new('('+@@nterm_tokenItem.source+')+')
	#~@@nterm_token=Regexp.new(@@term_token.source+@@nterm_tokenFolge.source)
	#~@@nterm_patternItem=Regexp.new(@@term_patternName.source+@@term_zuweisung.source+@@term_regexp.source)
	#~@@nterm_patternFolge=Regexp.new('('+@@nterm_patternItem.source+')+')
	#~@@nterm_pattern=Regexp.new(@@term_pattern.source+@@nterm_patternFolge.source)
	#~@@nterm_syntaxDefinition=Regexp.new(@@nterm_pattern.source+@@nterm_token.source)

	@@tokenArray=[@@term_pattern,@@term_token,@@term_zuweisung,@@term_regexp,@@term_patternName,@@term_tokenName]
	
# ==zerlege(input)
# Diese Methode zerlegt einen Eingabestring in seine Bestandteile,
# die durch Ruby-Patterns gegeben sind
# Allerdings werden die einzelnen Teile nicht den Tokenklassen zugeordnet,
# sondern nur in ein Array geschrieben, welches von der Methode dann
# zurckgegeben wird. 

def zerlege(input)
  ergarray=Array.new(0)
	
	# Zusammenstellen des regulren Ausdrucks aus dem Token-Array
	tempStr="\\A("
	@@tokenArray.each do |regex|
		tempStr=tempStr+regex.source+"|"
	end
	tempStr=tempStr.chomp("|")
	tempStr=tempStr+("\)")
	tempRegexp=Regexp.new(tempStr)
	#print tempRegexp.source

  while (input.size > 0) do
    tokentemp=""
    c=(input.match(tempRegexp))
    if (c[0]!=nil and input.index(c[0])==0)
    tokentemp=c[0]
    end
    if(tokentemp=="")
			return Array.new
    end
    ergarray << tokentemp
    input=input.sub(tokentemp, '')
		input=input.strip
  end   
  return ergarray
end

def bestimmeToken(text)
  return "term_pattern "   if @@term_pattern.match(text).to_s == text
  return "term_token " if @@term_token.match(text).to_s == text
  return "term_zuweisung "  if @@term_zuweisung.match(text).to_s == text
  return "term_regexp "  if @@term_regexp.match(text).to_s == text
	return "term_tokenName "  if @@term_tokenName.match(text).to_s == text
	return "term_patternName "  if @@term_patternName.match(text).to_s == text
end

def bestimme(input)
  zerlege(input).each do |part|
    print(bestimmeToken(part))
    print("<<",part,">>\n")
  end
end

example="Pattern: hallo := <regexp>   Token: tokenname := nam1  tokenname2 := <regexp>"

erg = zerlege(example)

if erg.empty?
  print "Irregulaere Eingabe"
	
else
  print("+------------------------------------------------+\n")
  print("| Zerlegung ohne Zuordnung zu den Token-Klassen: |\n")
  print("+------------------------------------------------+\n\n")
  erg.each do |comp|
      print("<<",comp,">>  ")
  end
  print("\n\n")
  print("+-----------------------------------------------+\n")
  print("| Zerlegung mit Zuordnung zu den Token-Klassen: |\n")
  print("+-----------------------------------------------+\n\n")
  print("Akkumulierte Tokens: \n--------------------\n\n")
  bestimme(example)

end 

